#!/usr/bin/perl
#
$| = 1;
###############################################################################
# 設定ここから
#
our ($PW)      = 'password';    # 管理者パスワード
our ($roomMax) = 20;            # 部屋数の最大値

#
# 設定ここまで
###############################################################################
our ($datafolder) = './data';
our ($listpath)   = "./list.cgi";
require './jcode.pl';
&init_form;

#
#
our ($flag)    = $form{'flag'};
our ($mngrpw)  = $form{'mngrpw'};
our ($id)      = $form{'id'};
our ($name)    = $form{'name'};
our ($manager) = $form{'manager'};
our ($roompw)  = $form{'roompw'};

#
&header;

if ( $mngrpw eq $PW ) {
	&main_proc;
}
else {
	print "<div class=\"errormsg\">パスワードが違います。</div>";
}
&footer;
exit(0);

#
###############################################################################
# <summary>
#  メインスクリプト
# </summary>
# <param name=""></param>
# <remarks></remarks>
###############################################################################
sub main_proc {

	#メインルーチン
	if ( $flag eq "add" ) {
		&add_room;
	}
	elsif ( $flag eq "変更" ) {
		&change_room;
	}
	elsif ( $flag eq "削除" ) {
		&delete_room;
	}
	elsif ( $flag eq "上へ" ) {
		&upward;
	}
	elsif ( $flag eq "下へ" ) {
		&downward;
	}
	&show_list;
}

###############################################################################
# <summary>
#  部屋追加
# </summary>
# <param name=""></param>
# <remarks></remarks>
###############################################################################
sub add_room {

	# 入力チェック
	if ( ( $name eq "" ) || ( $manager eq "" ) || ( $roompw eq "" ) ) {
		print "<div class=\"status\">空欄があります。</div>\n";
		return;
	}
	unless ( $roompw =~ /[0-9a-zA-Z]/ ) {
		print "<div class=\"status\">パスワードは半角英数のみ使用可です。</div>\n";
		return;
	}

	# フォルダが無ければ作成
	if ( !-d $datafolder ) {
		mkdir $datafolder;
	}

	# 新部屋情報
	my ($line) = "$name,$manager,$roompw,,\n";
	my ($newID);
	if ( -e $listpath ) {
		my (@readlines) = &open_file($listpath);

		# id最大値取得
		my ($iMax) = 0;

		# 最大部屋数制限
		if ( $#readlines >= $roomMax ) {
			print "<div class=\"status\">作成出来る部屋数の最大を超えています。</div>";
			return;
		}
		foreach (@readlines) {
			my ($readID) = ( split( /,/, $_ ) )[0];
			my ($iCount) = ( split( /_/, $readID ) )[1];
			if ( $iCount >= $iMax ) {
				$iMax = $iCount;
			}
		}
		$iMax += 1;
		$newID = "item_" . $iMax;
		push( @readlines, "$newID,$line" );
		&write_file( $listpath, join( "", @readlines ) );
	}
	else {
		$newID = "item_1";
		&write_file( $listpath, "$newID,$line" );
	}
	my ($roomfile) = "$datafolder/" . $newID . ".dat";
	&write_file( $roomfile, "" );
	print "<div class=\"status\">追加しました。</div>";
}

###############################################################################
# <summary>
#  部屋情報変更
# </summary>
# <param name=""></param>
# <remarks></remarks>
###############################################################################
sub change_room {

	#空欄チェック
	if ( ( $id eq "" ) || ( $name eq "" ) || ( $manager eq "" ) || ( $roompw eq "" ) ) {
		print "<div class=\"status\">空欄があります。</div>";
		return;
	}
	unless ( $roompw =~ /[0-9a-zA-Z]/ ) {
		print "<div class=\"status\">パスワードは半角英数のみ使用可です。</div>\n";
		return;
	}

	#変更処理
	my (@newLines);
	my (@lines) = &open_file($listpath);
	foreach my $line (@lines) {
		my ($readID) = ( split( /,/, $line ) )[0];
		if ( $id eq $readID ) {
			$line = "$id,$name,$manager,$roompw,,\n";
		}
		push( @newLines, $line );
	}
	&write_file( $listpath, join( "", @newLines ) );
	print "<div class=\"status\">$id を変更しました。</div>";
}

###############################################################################
# <summary>
#  部屋削除
# </summary>
# <param name=""></param>
# <remarks></remarks>
###############################################################################
sub delete_room {
	my (@lines) = &open_file($listpath);
	my (@newLines);
	foreach my $line (@lines) {
		my ($readID) = ( split( /,/, $line ) )[0];
		if ( $id ne $readID ) {
			push( @newLines, $line );
		}
	}
	&write_file( $listpath, join( "", @newLines ) );
	unlink "$datafolder/$id.dat";
	print "<div class=\"status\">$id を削除しました。</div>";
}

###############################################################################
# <summary>
#  部屋を上に移動
# </summary>
# <param name=""></param>
# <remarks></remarks>
###############################################################################
sub upward {
	my (@lines) = &open_file($listpath);
	@lines = reverse @lines;
	@lines = &reorder(@lines);
	@lines = reverse @lines;
	if ( $#lines == -1 ) {
		print "<div class=\"status\">移動できません。</div>";
	}
	else {
		&write_file( $listpath, join( "", @lines ) );
		print "<div class=\"status\">$id を移動しました。</div>";
	}
}

###############################################################################
# <summary>
#  部屋を下に移動
# </summary>
# <param name=""></param>
# <remarks></remarks>
###############################################################################
sub downward {
	my (@lines) = &open_file($listpath);
	@lines = &reorder(@lines);
	if ( $#lines == -1 ) {
		print "<div class=\"status\">移動できません。</div>";
	}
	else {
		&write_file( $listpath, join( "", @lines ) );
		print "<div class=\"status\">$id を移動しました。</div>";
	}

}

###############################################################################
# <summary>
#  部屋一覧
# </summary>
# <param name=""></param>
# <remarks></remarks>
###############################################################################
sub show_list {

	# 部屋一覧
	print "<div class=\"outer\">\n";
	print "<h1>管理者用予約設定</h1>\n";
	print "<h2>管理設備一覧</h2>\n";
	if ( -f $listpath ) {
		print "<table border=\"1\">\n";
		print "  <tr>\n";
		print "    <th class=\"cap\">データ名</th>\n";
		print "    <th class=\"cap\">設備名称</th>\n";
		print "    <th class=\"cap\">管理者名</th>\n";
		print "    <th class=\"cap\">パスワード</th>\n";
		print "    <th class=\"cap\">移動</th>\n";
		print "    <th class=\"cap\"><br /></th>\n";
		print "  </tr>\n";
		my (@lines) = &open_file($listpath);

		foreach (@lines) {
			chomp;
			my ( $readID, $readName, $readManager, $readPw, $readStart ) = split( /,/, $_ );
			print "  <form name=\"form1\" method=\"post\" action=\"./manage.cgi\">\n";
			print "    <tr>\n";
			print "      <td class=\"cap\"><div align=\"center\">$readID</div></td>\n";
			print "      <td class=\"cap\"><div align=\"center\"><input type=\"text\" name=\"name\" value=\"$readName\"></div></td>\n";
			print "      <td class=\"cap\"><div align=\"center\"><input type=\"text\" name=\"manager\" value=\"$readManager\"></div></td>\n";
			print "      <td class=\"cap\"><div align=\"center\"><input type=\"text\" name=\"roompw\" value=\"$readPw\"></div></td>\n";
			print "      <td class=\"cap\"><div align=\"center\"><input type=\"submit\" name=\"flag\" value=\"上へ\"><input type=\"submit\" name=\"flag\" value=\"下へ\"></div></td>\n";
			print "      <td class=\"cap\"><div align=\"center\"><input type=\"submit\" name=\"flag\" value=\"変更\"><input type=\"submit\" name=\"flag\" value=\"削除\"></div></td>\n";
			print "    </tr>\n";
			print "    <input type=\"hidden\" name=\"id\" value=\"$readID\">\n";
			print "    <input type=\"hidden\" name=\"mngrpw\" value=\"$mngrpw\">\n";
			print "  </form>\n";
		}
		print "</table>\n";
	}

	# 部屋追加フォーム
	print "<h2>設備の追加</h2>\n";
	print "<table border=\"1\">\n";
	print "  <tr>\n";
	print "    <th class=\"cap\">データ名</th>\n";
	print "    <th class=\"cap\">設備名称</th>\n";
	print "    <th class=\"cap\">管理者名</th>\n";
	print "    <th class=\"cap\">パスワード</th>\n";
	print "    <th class=\"cap\"><br /></th>\n";
	print "  </tr>\n";
	print "  <form name=\"form1\" method=\"post\" action=\"./manage.cgi\">\n";
	print "    <tr>\n";
	print "      <td class=\"cap\"><div align=\"center\">自動取得</div></td>\n";
	print "      <td class=\"cap\"><div align=\"center\"><input type=\"text\" name=\"name\"></div></td>\n";
	print "      <td class=\"cap\"><div align=\"center\"><input type=\"text\" name=\"manager\"></div></td>\n";
	print "      <td class=\"cap\"><div align=\"center\"><input type=\"text\" name=\"roompw\" style=\"ime-mode: disabled;\"></div></td>\n";
	print "      <td class=\"cap\"><div align=\"center\"><input type=\"submit\" value=\"追加\"></div></td>\n";
	print "    </tr>\n";
	print "    <input type=\"hidden\" name=\"flag\" value=\"add\">\n";
	print "    <input type=\"hidden\" name=\"mngrpw\" value=\"$mngrpw\">\n";
	print "  </form>\n";
	print "</table>\n";
	print "<br />\n";
	print "<form action=\"./\">\n";
	print "<input type=\"submit\" value=\"予約一覧に戻る\">\n";
	print "</form>\n";
	print "</div>\n";

}

###############################################################################
# <summary>
#  部屋順変更
# </summary>
# <param name=""></param>
# <remarks></remarks>
###############################################################################
sub reorder {
	my (@newLines);
	my ($matchLine);
	my (@inLines) = @_;
	my ($bRet)    = 0;
	my ($chkItem) = ( split( /,/, $inLines[$#inLines] ) )[0];
	if ( $id eq $chkItem ) {
		return;
	}

	foreach my $line (@inLines) {
		my ($readID) = ( split( /,/, $line ) )[0];
		if ( $id eq $readID ) {

			# マッチしていたら行をキープ
			$matchLine = $line;
			$bRet      = 1;
		}
		else {

			# マッチしていない行はそのまま配列に追加
			push( @newLines, $line );
			if ( $bRet == 1 ) {

				# マッチ行の後なら配列に追加
				push( @newLines, $matchLine );
				$bRet = 0;
			}
		}
	}
	return @newLines;
}

###############################################################################
# <summary>
#  ヘッダー
# </summary>
# <param name=""></param>
# <remarks></remarks>
###############################################################################
sub header {
	print "Content-type: text/html\n\n";
	print "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/html4/loose.dtd\">\n";
	print "<html>\n";
	print "<head>\n";
	print "<title>管理者ページ</title>\n";
	print "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n";
	print "<link href=\"./style.css\" rel=\"stylesheet\" type=\"text/css\">\n";
	print "</head>\n";
	print "<body>\n";
}

###############################################################################
# <summary>
#  フッター
# </summary>
# <param name=""></param>
# <remarks></remarks>
###############################################################################
sub footer {
	print "</body>\n";
	print "</html>\n";
}

###############################################################################
# <summary>
#  ファイルオープン
# </summary>
# <param name=""></param>
# <remarks></remarks>
###############################################################################
sub open_file {
	my ($fname) = @_;
	open( IN, $fname )
	  || die print "読み込みファイルのオープンに失敗しました";
	eval("flock (IN, 2 )");
	my (@lines) = <IN>;
	close(IN);
	return @lines;
}

###############################################################################
# <summary>
#  ファイル書き込み
# </summary>
# <param name=""></param>
# <remarks></remarks>
###############################################################################
sub write_file {
	my ( $file, $lines ) = @_;
	open( OUT, ">$file" ) || die print "書き込みファイルのオープンに失敗しました";
	eval("flock( OUT, 2 )");
	print OUT $lines;
	close OUT;
}

###############################################################################
# <summary>
#  日本語処理
# </summary>
# <param name=""></param>
# <remarks></remarks>
###############################################################################
sub init_form {
	my ( $query, @assocarray, $assoc, $property, $value, $method );
	$method = $ENV{'REQUEST_METHOD'};
	$method =~ tr/A-Z/a-z/;
	if ( $method eq 'post' ) {
		read( STDIN, $query, $ENV{'CONTENT_LENGTH'} );
	}
	else {
		$query = $ENV{'QUERY_STRING'};
	}
	@assocarray = split( /&/, $query );
	foreach $assoc (@assocarray) {
		( $property, $value ) = split( /=/, $assoc );
		$value =~ tr/+/ /;
		$value =~ s/%([A-Fa-f0-9][A-Fa-f0-9])/pack("C", hex($1))/eg;
		&jcode'convert( *value, "utf-8" );    # '
		$value =~ s/&/&amp;/g;
		$value =~ s/"/quot;/g;
		$value =~ s/</&lt;/g;
		$value =~ s/>/&gt;/g;
		$value =~ s/\t//g;
		$value =~ s/\r//g;
		$value =~ s/\,/&#44;/g;
		$form{$property} = $value;
	}
}

